/**************************************************************

File Name:		IIR_bctest.asm
		
Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1 Silicon
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SEGMENT syntax

Description:	ADSP-21364 multichannel SIMD program to call 
				CASCADE_BC.asm.  The input and output buffers are
		 		interleaved.  The coeficients buffer is a single
				array of coeficients which gets broadcasted to
				explicit and implicit registers.

**************************************************************/
#include "def21364.h"

.EXTERN cascaded_biquad, cascaded_biquad_init;
.GLOBAL coefs, dline;
.PRECISION=40;
.ROUND_NEAREST;

#define SAMPLES 256
#define SECTIONS 3

.SECTION/DM    seg_dmda;
.VAR    inbuf[2*SAMPLES]= "indata1.dat";     /* input7.dat */
.VAR    outbuf[2*SAMPLES];                	/* ends up holding response */
.VAR    dline[2*SECTIONS*2];              	/* w``, w`, NEXT w``, NEXT w`, ... */


.SECTION/PM    seg_pmda;
.VAR    coefs[SECTIONS*4]="iircoefs.dat";   /* a12,a11,b12,b11,a22,a21,... */


.SECTION/PM    seg_rth;
Reserved_1:		rti; nop; nop; nop;
Chip_Reset:		idle; jump begin; nop; nop;
	


.SECTION/PM    seg_pmco;
begin:  m1=2; 							/* modified for SIMD */
		m2=1;
		m8=1;
		l0=12; 							/* delay line circular buffer */
		l1=0;
 	    l3=0;
		l4=0;
		l9=12;
		r0=SECTIONS;
		r1=SAMPLES;						/* setup loop counter */
		r5=4*SECTIONS;
		b0=dline;
		call cascaded_biquad_init (db);     /* zero the delay line */
		b1=b0;
		b9=coefs;
filt:	call cascaded_biquad (db);      /* input=F8, output=F8 */
        b3=inbuf;        
		b4=outbuf;
done:   jump filt;
		nop;
		nop;

